internal class HeaderComboBoxCreationFilter : IUIElementCreationFilter
    {
        public void AfterCreateChildElements(UIElement parent)
        {
            if (parent is HeaderUIElement)
            {
                EditorWithComboUIElement comboBoxUIElement = (EditorWithComboUIElement)parent.GetDescendant(typeof(EditorWithComboUIElement));
                UltraGridComboEditorOwner embeddableEditor = null;
                EditorWithCombo editor = null;
                UltraCombo combo = null;

                combo = new UltraCombo();
                embeddableEditor = new UltraGridComboEditorOwner(combo);
                editor = new EditorWithCombo(embeddableEditor);
                comboBoxUIElement = new EditorWithComboUIElement(parent, embeddableEditor, editor, null, true, true, true, true);

                combo.DataSource = CreateColumnDataTable();
                combo.DisplayMember = "name";
                combo.ValueMember = "value";
                //combo.Text = "Text1";
                combo.SelectedRow = combo.Rows[0];
                combo.Appearance.ForeColor = Color.Indigo; // this does not have an effect
                combo.DropDownStyle = UltraComboStyle.DropDown;
                combo.DropDownButtonDisplayStyle = Infragistics.Win.ButtonDisplayStyle.Always;

                comboBoxUIElement.Rect = parent.Rect;
                
                parent.ChildElements.Add(comboBoxUIElement);             
            }           
        }

        private DataTable CreateColumnDataTable()
        {
            DataTable dataTable = new DataTable();
            dataTable.Columns.Add("name", typeof(string));
            dataTable.Columns.Add("value", typeof(string));

            dataTable.Rows.Add(new object[] { "Name1", "Value1" });
            dataTable.Rows.Add(new object[] { "Name2", "Value2" });
            dataTable.AcceptChanges();

            return dataTable;
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
    }